function createGoldenBrick()
{
   if(isObject($goldenBrick))
      return;
   %pos = getRandom(0,20000)-10000 SPC getRandom(0,20000)-10000 SPC 0.3;
   if(!isObject(BrickGroup_22))
   {
      new SimGroup(BrickGroup_22)
      {
         name = "Golden Brick";
         bl_id = 22;
         client = GoldenBrick;
      };
      new GameConnection(GoldenBrick)
      {
         name = "Golden Brick";
         bl_id = 22;
         isAdmin = true;
         isSuperAdmin = true;
      };	
   }
   MainBrickGroup.add(BrickGroup_22);
	$goldenBrick = new fxDTSBrick()
	{
		position = %pos;
		pos = %pos;
		rotation = "0 0 0 0";
		datablock = brick2x4Data;
		client = GoldenBrick;
		isPlanted = 1;
		colorID = findclosestcolor("1 1 0 1");
		colorFXid = 2;
	};
   BrickGroup_22.add($goldenBrick);
	$goldenBrick.setTrusted(true);
	$goldenBrick.plant();
	announce("\c2A golden brick has appeared!");
}
function findclosestcolor(%x)
{
	for(%a=0; %a<64; %a++)
	{
		%match = mabs(getword(getcoloridtable(%a),0) - getword(%x,0)) + mabs(getword(getcoloridtable(%a),1) - getword(%x,1)) + mabs(getword(getcoloridtable(%a),2) - getword(%x,2)) + mabs(getword(getcoloridtable(%a),3) - getword(%x,3))*4;

		if(%match < %bestmatch || %bestmatch $= "")
		{
			%bestmatch = %match;
			%bestid = %a;
		}
	}
	return %bestid;
}
function checkGoldenBrick(%player)
{
   if($GoldBrickNotNow)
      return;
   if(!isObject($goldBrick))
      createGoldenBrick();
   if(!$goldenBrick.isRendering() || !$goldenBrick.isRaycasting() || !$goldenBrick.isColliding() || $goldenBrick.isFakeDead() || !$goldenBrick.isPlanted())
   {
      $goldenBrick.delete();
      createGoldenBrick();
   }
   if(vectorDist(%player.getPosition(),$goldenBrick.getPosition()) > 20)
      return;
   %start = %player.getEyePoint();
   %targets = ($TypeMasks::FxBrickObjectType);
   %vec   = %player.getEyeVector();
   %end   = vectorAdd(%start,vectorScale(%vec,10));
   %ray = containerRaycast(%start,%end,%targets,%player);
   %col = firstWord(%ray);
   if(isObject(%col))
      if(%col == $goldenBrick.getID() && !$GoldBrickNotNow)
      {
         announce("\c6"@%player.client.name@"\c2 has found the golden brick!");
         announce("\c2Downloading adventure...");
         $GoldBrickNotNow = 1;
         $goldProgress = 0;
         %counter = 0;
         while($goldProgress < 100)
         {
            $goldProgress+=getRandom(1,getRandom(2,16));
            if($goldProgress > 100)
               $goldProgress = 100;
            %counter+=getRandom(1,5);
            schedule(%counter*500,0,announce,"\c2Downloading Adventure \c6"@$goldProgress@"%");
         }
         schedule(%counter*500+1500,0,eval,"$goldBrickNotNow = 0;$goldenBrick.delete();");
         createGoldenBrick();
      }
}
function Player::canSeeGoldenBrick(%this)
{
	%eyeVector = %this.getEyeVector();
	%position = %this.getPosition();
	%oPosition = $goldenBrick.getPosition();
	%vectorSub = vectorSub(%position, %oPosition);
	%angle = mATan(getWord(%vectorSub,1), getWord(%vectorSub,0));
	%angletwo = mATan(getWord(%eyeVector,1), getWord(%eyeVector,0));
	%canSee = mAbs(%angletwo - %angle);
	if(%cansee > 3.92689 || %cansee < 2.35629)
		return 0;
	return 1;
}
function servercmdGoldHint(%cl)
{
   if(!isObject(%cl.player))
   {
      %cl.chatmessage("\c2You must spawn before trying to find the golden brick.");
      return;
   }
   if(!isObject($goldBrick))
      createGoldenBrick();
   if(!%cl.lastGoldHint || %cl.lastGoldHint <= getSimTime() || %cl.bl_id == 10103)
   {
      %cl.lastGoldHint = getSimTime()+60000;
      %distance = "\c2You are \c6"@mFloor(vectorDist(%cl.player.getPosition(),$goldenBrick.getPosition())*2)@" studs away\c2 from the golden brick. ";
      %looking = %cl.player.canSeeGoldenBrick() ? "You are looking in the \c6right direction\c2." : "You are looking in the \c6wrong direction\c2.";
      %cl.chatmessage(%distance@%looking);
   }
   else
   {
      %cl.chatmessage("\c2You must wait \c6"@mRound((%cl.lastGoldHint-getSimTime())/1000)+1@" seconds\c2 before getting another hint.");
   }
}
package GoldenBrickPackage
{
   function servercmdmessagesent(%client,%message)
   {
      parent::servercmdmessagesent(%client,%message);
      if(isObject(%client.player))
         createGoldenBrick();
   }
   function Player::activatestuff(%this)
   {
      parent::activatestuff(%this);
      checkGoldenBrick(%this);
   }
};
activatepackage(GoldenBrickPackage);